diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorAurora.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorAurora.java
new file mode 100644
index 000000000..321b3d0c8
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorAurora.java
@@ -0,0 +1,139 @@
+package net.minecraft.client.render.tessellator;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.renderer.DrawMode;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.nio.ByteBuffer;
+
+public class TessellatorAurora {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final int VERT_SIZE = 8 * Float.BYTES + 8;
+
+    private boolean quadEmulation = false;
+
+    public final @NotNull String name;
+    public @NotNull ByteBuffer data;
+
+    protected double offsetX;
+    protected double offsetY;
+    protected double offsetZ;
+
+    public @NotNull DrawMode drawMode = DrawMode.TRIANGLES;
+    public boolean drawing;
+    public int vertexCount;
+    private int quadVertCount = 0;
+
+    public TessellatorAurora(@NotNull String name, int initialCapacity) {
+        this.name = name;
+        this.data = BufferUtils.createByteBuffer(initialCapacity);
+    }
+
+    public void startDrawing(@NotNull DrawMode drawMode) {
+        if (this.drawing) {
+            this.drawing = false;
+            throw new IllegalStateException(this.name + "Already drawing!");
+        }
+
+        if (drawMode == DrawMode.QUADS && Tessellator.QUAD_EMULATION) {
+            this.drawMode = DrawMode.TRIANGLES;
+            this.quadEmulation = true;
+        } else {
+            this.drawMode = drawMode;
+        }
+        this.drawing = true;
+        this.vertexCount = 0;
+        this.quadVertCount = 0;
+
+        this.data.clear();
+    }
+
+    public void setTranslation(double x, double y, double z) {
+        this.offsetX = x;
+        this.offsetY = y;
+        this.offsetZ = z;
+    }
+
+    public void offsetTranslation(double x, double y, double z) {
+        this.offsetX += x;
+        this.offsetY += y;
+        this.offsetZ += z;
+    }
+
+    public void checkIsDrawing() {
+        if (!this.drawing) {
+            throw new IllegalStateException(this.name + " not drawing!");
+        }
+    }
+
+    public void checkCanFit(int size) {
+        if (this.data.capacity() < this.data.position() + size) {
+            int newSize = this.data.capacity() * 2;
+
+            LOGGER.info("Expanding {} Buffer ({} -> {})", this.name, this.data.capacity(), newSize);
+
+            ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+            this.data.flip();
+            newBuffer.put(this.data);
+            this.data = newBuffer;
+        }
+    }
+
+    public void addVertex(double x, double y, double z, double xo, double yo, double zo, float r, float g, float b, float a, float ro, float go, float bo, float ao, float u, float v) {
+        checkIsDrawing();
+        checkCanFit(128);
+
+        this.data.putFloat((float) (x + this.offsetX)).putFloat((float) (y + this.offsetY)).putFloat((float) (z + this.offsetZ));
+        this.data.putFloat((float) (xo + this.offsetX)).putFloat((float) (yo + this.offsetY)).putFloat((float) (zo + this.offsetZ));
+
+        this.data.putInt(((int) (a * 255) & 0xFF) << 24 | ((int) (b * 255) & 0xFF) << 16 | ((int) (g * 255) & 0xFF) << 8 | (int) (r * 255) & 0xFF);
+        this.data.putInt(((int) (ao * 255) & 0xFF) << 24 | ((int) (bo * 255) & 0xFF) << 16 | ((int) (go * 255) & 0xFF) << 8 | (int) (ro * 255) & 0xFF);
+
+        this.data.putFloat(u).putFloat(v);
+
+        this.vertexCount++;
+
+        if (this.quadEmulation && this.quadVertCount % 4 == 2) {
+            int vertSize = VERT_SIZE;
+
+            checkCanFit(256);
+            this.data.put(this.data.position(), this.data, this.data.position() - vertSize * 3, vertSize);
+            this.data.put(this.data.position() + vertSize, this.data, this.data.position() - vertSize, vertSize);
+            this.data.position(this.data.position() + vertSize * 2);
+            this.vertexCount += 2;
+        }
+
+        this.quadVertCount++;
+    }
+
+    public @NotNull RenderBuffer record(int vao, int vbo) {
+        checkIsDrawing();
+        this.drawing = false;
+
+        enable(vao, vbo);
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
+        GL41.glBindVertexArray(0);
+        return new RenderBuffer(vao, vbo, 0, this.vertexCount, this.drawMode);
+    }
+
+    public void enable(int vao, int vbo) {
+        GL41.glBindVertexArray(vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+        int offset = 0;
+        GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, offset); offset += Float.BYTES * 3; // Pos
+        GL41.glVertexAttribPointer(1, 3, GL41.GL_FLOAT, false, VERT_SIZE, offset); offset += Float.BYTES * 3; // PosO
+        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, VERT_SIZE, offset); offset += 4; // Color
+        GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true, VERT_SIZE, offset); offset += 4; // ColorO
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false, VERT_SIZE, offset); offset += 2; // UV
+
+        GL41.glEnableVertexAttribArray(0);
+        GL41.glEnableVertexAttribArray(1);
+        GL41.glEnableVertexAttribArray(2);
+        GL41.glEnableVertexAttribArray(3);
+        GL41.glEnableVertexAttribArray(4);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java
index 90a2348c4..e8694c184 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTextured.java
@@ -1,5 +1,9 @@
 package net.minecraft.client.render.tessellator;
 
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
+
 public interface TessellatorTextured extends Tessellator {
     void setTextureUV(double u, double v);
 
@@ -7,6 +11,12 @@ public interface TessellatorTextured extends Tessellator {
         setTextureUV(u, v);
         addVertex(x, y, z);
     }
+    default void addVertexWithUV(@NotNull Vector3dc pos, double u, double v) {
+        addVertexWithUV(pos.x(), pos.y(), pos.z(), u, v);
+    }
+    default void addVertexWithUV(@NotNull Vector3fc pos, double u, double v) {
+        addVertexWithUV(pos.x(), pos.y(), pos.z(), u, v);
+    }
 
     default void drawRectangleWithUV(int x, int y, int width, int height, double u, double v, double uvWidth, double uvHeight) {
         this.addVertexWithUV(x, y, 0.0D, u, v);
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 1e1312569..5e70813f2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.sound.SoundRepository;
@@ -105,6 +106,7 @@ public class TexturePackList
 		}
 		mc.textureManager.updateDynamicTextures(false);
 		SoundRepository.reload();
+		BlockColorDispatcher.getInstance().reload();
 		BlockModelDispatcher.getInstance().reload();
 		ItemModelDispatcher.getInstance().reload();
 		EntityGeometryMojangData.Cache.reload(this);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index a897e1903..f1469c18b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -33,8 +33,8 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
     @Override
     public void doRender(TessellatorGeneral tessellator, TileEntityMovingPistonBlock tileEntity, double x, double y, double z,
                          float partialTick) {
-        Block<?> block = Blocks.getBlock(tileEntity.getMovedId());
-        if (block != null && tileEntity.getProgress(partialTick) < 1.0F) {
+        Block<?> block = tileEntity.getMovedBlock();
+        if (tileEntity.getProgress(partialTick) < 1.0F) {
             if (this.container == null || this.container.world != tileEntity.worldObj) {
                 this.container = new BlocksContainer(tileEntity.worldObj);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java
index 8a691c93e..72eb0f5e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java
@@ -6,6 +6,8 @@ import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.render.FogManager;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Matrix4f;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+import org.useless.dragonfly.models.entity.mojang.StaticEntityModelMojang;
 
 import java.nio.ByteBuffer;
 import java.util.Map;
@@ -28,6 +30,7 @@ public class UniformBlockManager {
             return dest;
         }
     });
+    public static final @NotNull UniformBlock<Matrix4f> BLOCK_ENTITY_BONES = register("Bones", 3, N * 4 * StaticEntityModelMojang.MAX_BONES, Matrix4f::get);
 
     public static <T> UniformBlock<T> register(@NotNull String name, int index, int size, @NotNull BufferAdapter<T> adapter) {
         UniformBlock<T> block = new UniformBlock<>(name, index, size, adapter);
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index f96c1404e..33d113393 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.worldtype;
 
 import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -62,7 +63,7 @@ public class WorldTypeFXNether extends WorldTypeFX {
                 double ry = (player.y - radius) + (world.rand.nextDouble() * radius * 2);
                 double rz = (player.z - radius) + (world.rand.nextDouble() * radius * 2);
 
-                if (world.getBlockId(new TilePos(rx, ry, rz)) == 0) {
+                if (world.getBlockType(new TilePos(rx, ry, rz)) == Blocks.AIR) {
                     world.spawnParticle("ashmote", rx, ry, rz, 0, 0, 0, 0);
                 }
             }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 357f31b68..a8ec4bc9d 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -4,6 +4,7 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
@@ -96,7 +97,7 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-    public void scheduleBlockUpdate(final @NotNull TilePosc tilePos, final int id, final long delay) {
+    public void scheduleBlockUpdate(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final long delay) {
         // Do nothing
     }
 
@@ -175,10 +176,10 @@ public class WorldClientMP extends WorldClient {
 
     @Override
     public boolean setBlockData(final @NotNull TilePosc tilePos, final int data) {
-        final int id = this.getBlockId(tilePos);
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
         final int currentData = this.getBlockData(tilePos);
         if (super.setBlockData(tilePos, data)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), id, currentData));
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), block.id(), currentData));
             return true;
         } else {
             return false;
@@ -186,11 +187,11 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data) {
-        final int currentId = this.getBlockId(tilePos);
+    public boolean setBlockTypeData(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
+        final @NotNull Block<?> currentBlock = this.getBlockType(tilePos);
         final int currentData = this.getBlockData(tilePos);
-        if (super.setBlockIdData(tilePos, id, data)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentId, currentData));
+        if (super.setBlockTypeData(tilePos, block, data)) {
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentBlock.id(), currentData));
             return true;
         } else {
             return false;
@@ -198,11 +199,11 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-    public boolean setBlockId(final @NotNull TilePosc tilePos, final int id) {
-        final int currentId = this.getBlockId(tilePos);
-        final int data = this.getBlockData(tilePos);
-        if (super.setBlockId(tilePos, id)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentId, data));
+    public boolean setBlockType(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        final @NotNull Block<?> currentBlock = this.getBlockType(tilePos);
+        final int currentData = this.getBlockData(tilePos);
+        if (super.setBlockType(tilePos, block)) {
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentBlock.id(), currentData));
             return true;
         } else {
             return false;
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
index 1a218ddfe..813b609a0 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
@@ -10,6 +10,8 @@ import com.google.gson.JsonSerializer;
 import net.minecraft.core.util.helper.Direction;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 import org.useless.util.GsonHelper;
 
 import java.lang.reflect.Type;
@@ -21,10 +23,10 @@ public class Cube {
     public final double @NotNull [] size;
     public final @Nullable Face @NotNull [] faces;
     public final double inflate;
-    public final double @NotNull [] pivot;
-    public final double @Nullable [] rotation;
+    public final @NotNull Vector3dc pivot;
+    public final @Nullable Vector3dc rotation;
 
-    protected Cube(final double @NotNull [] origin, final double @NotNull [] size, final @Nullable Face.Builder @NotNull [] faces, final double inflate, final double @NotNull [] pivot, final double @Nullable [] rotation) {
+    protected Cube(final double @NotNull [] origin, final double @NotNull [] size, final @Nullable Face.Builder @NotNull [] faces, final double inflate, final @NotNull Vector3d pivot, final @Nullable Vector3d rotation) {
         this.origin = origin;
         this.size = size;
         this.pivot = pivot;
@@ -43,8 +45,8 @@ public class Cube {
         private final double @NotNull [] size;
         private final @Nullable Face.Builder @NotNull [] faces;
         private double inflate;
-        private final double @NotNull [] pivot;
-        private double @Nullable [] rotation = null;
+        private final @NotNull Vector3d pivot;
+        private @Nullable Vector3d rotation = null;
         private boolean mirror;
 
         public Builder(
@@ -55,7 +57,7 @@ public class Cube {
             this.size = new double[]{sX, sY, sZ};
             this.faces = new Face.Builder[6];
             this.inflate = 0;
-            this.pivot = new double[]{0, 0, 0};
+            this.pivot = new Vector3d();
         }
 
         public Builder(
@@ -66,7 +68,7 @@ public class Cube {
             this.size = size;
             this.faces = new Face.Builder[6];
             this.inflate = 0;
-            this.pivot = new double[]{0, 0, 0};
+            this.pivot = new Vector3d();
         }
 
         public @NotNull Builder setFaces(final double u, final double v) {
@@ -93,17 +95,13 @@ public class Cube {
         }
 
         public @NotNull Builder setPivot(final double x, final double y, final double z) {
-            this.pivot[0] = x;
-            this.pivot[1] = y;
-            this.pivot[2] = z;
+            this.pivot.set(x, y, z);
             return this;
         }
 
         public @NotNull Builder setRotation(final double x, final double y, final double z) {
-            if (this.rotation == null) this.rotation = new double[3];
-            this.rotation[0] = x;
-            this.rotation[1] = y;
-            this.rotation[2] = z;
+            if (this.rotation == null) this.rotation = new Vector3d();
+            this.rotation.set(x, y, z);
             return this;
         }
 
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 7aa17e976..255686b42 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -6,11 +6,8 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
-import net.minecraft.client.render.renderer.GLRenderer;
-import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Color;
@@ -26,7 +23,6 @@ import org.joml.Vector3d;
 import org.joml.Vector3dc;
 import org.joml.Vector3f;
 import org.joml.Vector3fc;
-import org.lwjgl.opengl.GL41;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 import org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData;
@@ -55,18 +51,10 @@ public class StaticBlockModelMojang implements StaticBlockModel {
     public boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, int lightmapCoord, @NotNull BlockColor color) {
         if (this.compiled.elements.length == 0) return false;
 
-        GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.TERRAIN);
-        GL41.glActiveTexture(GL41.GL_TEXTURE2);
-        TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
-//        GL41.glActiveTexture(GL41.GL_TEXTURE3);
-//        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
-        GL41.glActiveTexture(GL41.GL_TEXTURE0);
         tessellator.startDrawingQuads();
         for (int i = 0; i < this.compiled.elements.length; i++) {
             C_Element element = this.compiled.elements[i];
 
-            tessellator.setColor1i(0xFFFFFFFF);
             tessellator.setLightmapCoord1i(lightmapCoord);
             for (int face = 0; face < element.faces; face++) {
                 IconCoordinate coordinate = element.textures[face];
@@ -97,7 +85,6 @@ public class StaticBlockModelMojang implements StaticBlockModel {
             }
         }
         tessellator.draw();
-        GLRenderer.popFrame();
         return true;
     }
 
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
index a57695dc8..aa9619f2a 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
@@ -9,4 +9,5 @@ public interface StaticEntityModel {
     @NotNull AABBdc visibleBounds();
     void translateToBone(@NotNull String boneId);
     void render();
+    void delete();
 }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index 2b2969cd3..a74e34b68 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -4,11 +4,18 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.uniform.UniformBlockManager;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Math;
+import org.joml.Matrix4f;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.BufferUtils;
@@ -22,23 +29,25 @@ import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 import java.nio.ByteBuffer;
-import java.nio.FloatBuffer;
 import java.util.Map;
 
 public class StaticEntityModelMojang implements StaticEntityModel {
+    public static final int MAX_BONES = 128;
     private static final BoneTransform DUMMY_TRANSFORM = new BoneTransform();
-    private static final TessellatorEntity entityTessellator = new TessellatorEntity(8192);
+    private static final TessellatorEntity entityTessellator = new TessellatorEntity(16384);
     public final @NotNull Map<@NotNull String, @NotNull BoneTransform> transformMap = new Object2ObjectOpenHashMap<>();
     public final @NotNull BoneTransform @NotNull [] transforms;
-    public final @NotNull Bone @NotNull [] bones;
+    public final @NotNull BoneEntry @NotNull [] bones;
     public final EntityGeometryMojangData data;
     public final double inflation;
     protected final @NotNull AABBd visBounds;
 
+    private final @NotNull RenderBuffer renderBuffer;
+
     public StaticEntityModelMojang(final @NotNull EntityGeometryMojangData data, final double inflation) {
         this.data = data;
         this.transforms = new BoneTransform[this.data.bones.size()];
-        this.bones = new Bone[this.data.bones.size()];
+        this.bones = new BoneEntry[this.data.bones.size()];
         this.inflation = inflation;
 
         int i = 0;
@@ -46,7 +55,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             final BoneTransform transform = new BoneTransform();
             this.transformMap.put(entry.getKey(), transform);
             this.transforms[i] = transform;
-            this.bones[i] = entry.getValue();
+            this.bones[i] = new BoneEntry(entry.getValue(), i);
             i++;
         }
 
@@ -58,6 +67,12 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             (this.data.vBoundsOffset[1] + this.data.vBoundsHeight / 2),
             (this.data.vBoundsOffset[2] + this.data.vBoundsWidth / 2)
         );
+
+        entityTessellator.startDrawingQuads();
+        for (BoneEntry bone : this.bones) {
+            renderBone(entityTessellator, bone);
+        }
+        this.renderBuffer = entityTessellator.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
     }
 
     @Override
@@ -81,49 +96,73 @@ public class StaticEntityModelMojang implements StaticEntityModel {
     public void translateToBone(@NotNull final String boneId) {
         final Bone bone = this.data.bones.get(boneId);
         if (bone == null) return;
-        boneTransform(bone);
+        boneTransform(bone, mat.identity());
+        GLRenderer.modelM4f().mul(mat);
         GLRenderer.modelM4f().translate((float) bone.pivot[0], (float) bone.pivot[1], (float) bone.pivot[2]);
     }
-
+    private static final Matrix4f hiddenMat = new Matrix4f()
+        .set(0, 0, 0, 0,
+            0, 0, 0, 0,
+            0, 0, 0, 0,
+            0, 0, 0, 0);
     @Override
     public void render() {
-        GLRenderer.getShader().bind();
-        GLRenderer.globalSetUniforms(GLRenderer.getShader());
-        for (int i = 0; i < this.bones.length; i++) {
-            final Bone bone = this.bones[i];
-            GLRenderer.pushFrame();
-            if (!boneTransform(bone)) {
-                GL41.glUniformMatrix4fv(GLRenderer.getShader().getUniform("model"), false, GLRenderer.modelM4f().get(this.mat4fBuf));
-                renderBone(entityTessellator, bone);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.ENTITY);
+        GLRenderer.globalSetUniforms(Shaders.ENTITY);
+        Shaders.ENTITY.uniformVec2f("uLightmap", GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        {
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_ENTITY_BONES.ubo);
+            UniformBlockManager.BLOCK_ENTITY_BONES.buffer.clear();
+            int i = 0;
+            for (BoneEntry entry : this.bones) {
+                if (boneTransform(entry.bone(), mat.identity())) {
+                    UniformBlockManager.BLOCK_ENTITY_BONES.adapter.bufferData(hiddenMat, entry.index() * 16 * 4, UniformBlockManager.BLOCK_ENTITY_BONES.buffer);
+                } else {
+                    UniformBlockManager.BLOCK_ENTITY_BONES.adapter.bufferData(mat, entry.index() * 16 * 4, UniformBlockManager.BLOCK_ENTITY_BONES.buffer);
+                }
+                i++;
             }
-            GLRenderer.popFrame();
+            GL41.glBufferSubData(GL41.GL_UNIFORM_BUFFER, 0, UniformBlockManager.BLOCK_ENTITY_BONES.buffer.limit(i * 16 * 4));
+            GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, 0);
         }
+
+        GL41.glBindVertexArray(this.renderBuffer.vao());
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.renderBuffer.vbo());
+        GL41.glDrawArrays(this.renderBuffer.drawMode().cap, this.renderBuffer.offset(), this.renderBuffer.count());
+        GL41.glBindVertexArray(0);
+        GLRenderer.popFrame();
+    }
+
+    @Override
+    public void delete() {
+        this.renderBuffer.delete();
     }
 
-    protected boolean boneTransform(@NotNull final Bone bone) {
+    private static final @NotNull Matrix4f mat = new Matrix4f();
+    protected boolean boneTransform(@NotNull final Bone bone, @NotNull Matrix4f dest) {
         boolean hidden = false;
         final Bone parent = bone.parent != null ? this.data.bones.get(bone.parent) : null;
         if (parent != null) {
-            hidden |= boneTransform(parent);
+            hidden |= boneTransform(parent, dest);
         }
         final BoneTransform transform = this.transformMap.get(bone.name);
         hidden |= !transform.visible;
-        GLRenderer.modelM4f().translate((float) bone.pivot[0], (float) bone.pivot[1], (float) bone.pivot[2]);
-        GLRenderer.modelM4f().translate((float) transform.posX, (float) transform.posY, (float) transform.posZ);
-        GLRenderer.modelM4f().rotateZ((float) (-transform.rotZ - Math.toRadians(bone.rotation[2])));
-        GLRenderer.modelM4f().rotateY((float) (transform.rotY + Math.toRadians(bone.rotation[1])));
-        GLRenderer.modelM4f().rotateX((float) (-transform.rotX - Math.toRadians(bone.rotation[0])));
-        GLRenderer.modelM4f().translate((float) -bone.pivot[0], (float) -bone.pivot[1], (float) -bone.pivot[2]);
-        GLRenderer.modelM4f().scale((float) transform.scaleX, (float) transform.scaleY, (float) transform.scaleZ);
+        dest.translate((float) bone.pivot[0], (float) bone.pivot[1], (float) bone.pivot[2]);
+        dest.translate((float) transform.posX, (float) transform.posY, (float) transform.posZ);
+        dest.rotateZ((float) (-transform.rotZ - Math.toRadians(bone.rotation[2])));
+        dest.rotateY((float) (transform.rotY + Math.toRadians(bone.rotation[1])));
+        dest.rotateX((float) (-transform.rotX - Math.toRadians(bone.rotation[0])));
+        dest.translate((float) -bone.pivot[0], (float) -bone.pivot[1], (float) -bone.pivot[2]);
+        dest.scale((float) transform.scaleX, (float) transform.scaleY, (float) transform.scaleZ);
         return hidden;
     }
 
-    private final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
-
     private final double[] uvsBuffer = new double[8];
 
-    protected void renderBone(@NotNull final TessellatorEntity tessellator, @NotNull final Bone bone) {
-        tessellator.startDrawingQuads();
+    protected void renderBone(final @NotNull  TessellatorEntity tessellator, final @NotNull BoneEntry entry) {
+        tessellator.setBone(entry.index());
+        Bone bone = entry.bone();
         for (final Cube cube : bone.cubes) {
             final double minX = cube.origin[0] - (cube.inflate + bone.inflate + this.inflation);
             final double minY = cube.origin[1] - (cube.inflate + bone.inflate + this.inflation);
